@echo off

REM Make sense of what version of Java is on the path

SETLOCAL
PATH %PATH%;%JAVA_HOME%\bin\

java -fullversion 2> ver.txt
set /p test=<ver.txt

set s=%test:~19,3%

REM remove + sign if there is one
call:rTrim s +

REM script should take us to version 99

REM get first character
set /a f=%s:~0,1%

REM find position of decimal

SET str1=%s%
SET "sstr=."
SET stemp=%str1%&SET pos=0
:loop
SET /a pos+=1
echo %stemp%|FINDSTR /b /c:"%sstr%" >NUL
IF ERRORLEVEL 1 (
SET stemp=%stemp:~1%
IF DEFINED stemp GOTO loop
SET pos=0
)

REM get the last digit in case it's a pre-9 jdk
set /a v=%s:~-1%

if %f% EQU 1 (
	REM either version 10 or 1.6, 1.7, 1.8 etc
	
	if %pos% EQU 0 (
		set /a v=%s%
	)
) ELSE (

	set /a v=%f%
	
)	

if %v% LSS 6 (
	echo version not supported
	GOTO End
)

if %v% GTR 10 (
	start javaw -cp "./windows/*;./lib/*;./imageio/*;./nashorn/*" -splash:icon/splash.jpg photogrok.PhotoGrok
	GOTO End
)

if %v% EQU 6 (
	start javaw -cp "./windows/*;./lib/*" -splash:icon/splash.jpg photogrok.PhotoGrok
	GOTO End
)

if %v% EQU 7 (
	start javaw -cp "./windows/*;./lib/*" -splash:icon/splash.jpg com.javafx.main.Main
	GOTO End
)

start javaw -cp "./windows/*;./lib/*;./imageio/*" -splash:icon/splash.jpg photogrok.PhotoGrok

:rTrim string char max -- strips white spaces (or other characters) from the end of a string
::                     -- string [in,out] - string variable to be trimmed
::                     -- char   [in,opt] - character to be trimmed, default is space
::                     -- max    [in,opt] - maximum number of characters to be trimmed from the end, default is 32
:$created 20060101 :$changed 20080219 :$categories StringManipulation
:$source https://www.dostips.com
SETLOCAL ENABLEDELAYEDEXPANSION
call set string=%%%~1%%
set char=%~2
set max=%~3
if "%char%"=="" set char= &rem one space
if "%max%"=="" set max=32
for /l %%a in (1,1,%max%) do if "!string:~-1!"=="%char%" set string=!string:~0,-1!
( ENDLOCAL & REM RETURN VALUES
    IF "%~1" NEQ "" SET %~1=%string%
)

:END




