
var PAINTERLINKER = new (function(){
var painterList = [];
this.linked = false;
var _setPainter = setPainter;

this.addPainter = function(p, pid){

	if(!PAINTERLINKER.linked){
		_setPainter(p, pid);
		return;
	}
	if(p == null){
		for(var i = 0; i < painterList.length; i++){
			if(painterList[i].id === pid){
				//print('removing: ' + pid);
				painterList.splice(i, 1);
				break;	
			}
		}


		if(painterList.length == 0 || pid === 'reset'){
			_setPainter(null, pid);
			painterList = [];
			PAINTERLINKER.linked = pid !== 'reset';
			return;
		}
		linkPainters(pid);
	}else{
	

		if(typeof p === 'function'){
			var pObj = {};
			pObj.paint = p;
			painterList[painterList.length] = { 'id': pid, 'painter': pObj };
		}else{
			painterList[painterList.length] = { 'id': pid, 'painter': p };
		}
		if(painterList.length > 1){
			linkPainters(pid);
		}else{

			_setPainter(p, pid);
		}
	}
}

function linkPainters(pid){
	if(painterList.length > 0){
		
		var linkPainter = function(gfx, image, ig, pp){
			for(var i = 0; i < painterList.length; i++){
				painterList[i].painter.paint(gfx, image, ig, pp);					
			}		
		}
		
		_setPainter(linkPainter, pid);
		
	}
}

this.link = function(){
	painterList = [];
	_setPainter(null, 'link');
	PAINTERLINKER.linked = true;
}

this.unlink = function(){
	painterList = [];
	_setPainter(null, 'link');
	PAINTERLINKER.linked = false;
}

addUserCommand("Link", function(){
	PAINTERLINKER.link();
}, 'undefined');

addUserCommand("Unlink", function(){
	PAINTERLINKER.unlink();
}, 'undefined');
})();

var _linkedthis = this;

(function() {
    // log all calls to setPainter

    var proxied = PAINTERLINKER.addPainter;

    _linkedthis.setPainter = function() {
        return proxied.apply( this, arguments );

    };
})();

